;******************************************************************************************************
;;;public functions
;******************************************************************************************************

(defun INTEGNPS:DRAW_PLATE(fLong fWidth /)
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(setq old_osnap (getvar "osmode"))
	(setq PA (LIST 0 0))
	(setq PB (LIST fLong 0))
	(setq PC (LIST fLong fWidth))
	(setq PD (LIST 0 fWidth))
	(command "layer" "m" "9" "c" "8" "9" "s" "9" "")
	(command "osnap" "none")
	(command "ortho" "off")
	(command "pline" PA "W" "0" "0" PB PC PD PA "")
	(command "zoom" "e")
	(command "VIEWRES" "" "20000")
	(command "LIMITS" "off")
	(command "LIMITS" PA PC)
	(if (/= (getvar "griddisplay") nil)(setvar "griddisplay" 0))
	(setvar "osmode" old_osnap)
	(setvar "cmdecho" old_cmdmode)
	(command "layer" "s" "0" "")
	(print)
)

(defun INTEGNPS:DELETE_CNC_START_BLOCKS (/ blk ss i j k)
	(setq k 0)
	(setq j 0)
	(setq i 0)
	(setq blk "START")

	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)

	(setq ss (ssget "x"))

	(if (/= ss nil) 

		(repeat (sslength ss)
			(setq ent (ssname ss i))
			(if (= (cdr (assoc 0 (entget ent))) "INSERT")
				(if (= (strcase blk) (strcase (cdr (assoc 2 (entget ent)))))
					(progn
						(entdel ent)
						(setq j (1+ j))
					)
				)
			)
			(setq i (1+ i))
		)
	)

	(setvar "cmdecho" old_cmdmode)

	(print j)
) 

(defun INTEGNPS:CLEAR_CNC_START_BLOCKS(dcl_filename /) 

	(setq dcl_id (load_dialog dcl_filename)) 

	(
		if (not (new_dialog "PROMPR_CLEAR_CNC_START_BLOCKS_DIALOG" dcl_id)) 

			(exit)
	) 

	(setq bSuccess nil)
	
	(action_tile "accept" "(setq bSuccess T)(done_dialog)") 

	(action_tile "cancel" "(done_dialog)") 

	(start_dialog) 

	(unload_dialog dcl_id)
	
	(if (= bSuccess T)
		(INTEGNPS:SHELL_DELETE_CNC_START_BLOCKS)
		(redraw)
	)
	
	(print)

) 

;;;only for old version compatible
(defun CLEAR_CNC_START_BLOCKS(dcl_filename /) 
	(INTEGNPS:CLEAR_CNC_START_BLOCKS dcl_filename)
)

(defun INTEGNPS:EX_INSERT_BLOCK (file_name prior_insert_block_name block_layer block_color object_snap prompt_msg / insert_point)
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(setq old_insunits (getvar "insunits"))
	(setvar "insunits" 0)
	(if (/= nil object_snap) (command "osnap" object_snap))
	(command "layer" "m" block_layer "c" block_color block_layer "" "layer" "s" block_layer "")
	(while
		(setq insert_point (getpoint prompt_msg))
		(if (progn (= nil prior_insert_block_name) or (= nil (tblsearch "BLOCK" prior_insert_block_name)))
			(command "insert" file_name insert_point "1" "1" "0")
			(command "insert" prior_insert_block_name insert_point "1" "1" "0")
		)
	)
	(command "layer" "s" "0" "")
	(setvar "cmdecho" old_cmdmode)
	(setvar "insunits" old_insunits)
) 

(defun INTEGNPS:INSERT_BLOCK (file_name block_layer block_color object_snap prompt_msg /)
	(INTEGNPS:EX_INSERT_BLOCK file_name "START" block_layer block_color object_snap prompt_msg)
) 

(defun INTEGNPS:SET_LAYER_TO (block_layer block_color)
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(command "layer" "m" block_layer "c" block_color block_layer "")
	(command "layer" "s" block_layer "")
	(setvar "cmdecho" old_cmdmode)
) 

(defun INTEGNPS:CHANGE_LAYER (block_layer block_color selection_method)
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(command "layer" "m" block_layer "c" block_color block_layer "")
	(while
		(if (= selection_method nil)
			(setq ss (ssget))
			(setq ss (ssget selection_method))
		)
		(if (progn (/= ss nil) and (/= (sslength ss) 0))
			(progn
				(command "layer" "s" block_layer "")
				(command "change" ss "" "p" "layer" block_layer "c" block_color "")
			)
		)
			
	)
	(command "layer" "s" "0" "")
	(setvar "cmdecho" old_cmdmode)
) 

(defun INTEGNPS:CHANGE_OBJECT_TO_R12 (/ tmp_filename)
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(if (= (listp vl-filename-mktemp) nil)
		(progn
			(setq tmp_filename (vl-filename-mktemp "$.dxf"))
			(vl-file-delete tmp_filename)
		)
		(progn
			(setq tmp_filename "./$tmp$2_r12.dxf");;;AutoCAD R14 before version
		)
	)
	(setq ss (ssget))
	(if (and (/= ss nil) (> (sslength ss) 0))
		(progn
			(command "layer" "s" "0" "")
			(command "dxfout" tmp_filename)
			(command "V" "R12")
			(command "E" ss "")
			(command "16")
			(command "erase" "p" "")
			(command "dxfin" tmp_filename)
			
			(if (= (listp vl-file-delete) nil)
				(vl-file-delete tmp_filename);;;AutoCAD R14 later version
			)
		)
	)
	(setvar "cmdecho" old_cmdmode)
	(print)
)

(defun C:INTEGPS_CHANGE_CUT_START_TO_NORMAL_LAYER()
	(INTEGNPS:CHANGE_LAYER "1" "1" nil)
)

(defun C:INTEGPS_CHANGE_CUT_START_TO_INNORMAL_LAYER()
	(INTEGNPS:CHANGE_LAYER "2" "2" nil)
)

(defun C:INTEGPS_CHANGE_CUT_START_TO_NO_LEADER_NORMAL_LAYER()
	(INTEGNPS:CHANGE_LAYER "3" "3" nil)
)

(defun C:INTEGPS_CHANGE_CUT_START_TO_NO_LEADER_INNORMAL_LAYER()
	(INTEGNPS:CHANGE_LAYER "4" "4" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_OUTER_LAYER()
	(INTEGNPS:CHANGE_LAYER "0" "7" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_OUTER_BRIDGE_LAYER()
	(INTEGNPS:CHANGE_LAYER "1" "1" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_INNER_LAYER()
	(INTEGNPS:CHANGE_LAYER "3" "3" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_INNER_BRIDGE_LAYER()
	(INTEGNPS:CHANGE_LAYER "2" "2" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_POWDER_MARK_LAYER()
	(INTEGNPS:CHANGE_LAYER "6" "6" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_PUNCH_MARK_LAYER()
	(INTEGNPS:CHANGE_LAYER "5" "5" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_DRILLING_LAYER()
	(INTEGNPS:CHANGE_LAYER "4" "4" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_RIVETING_LAYER()
	(INTEGNPS:CHANGE_LAYER "8" "8" nil)
)

(defun C:INTEGPS_CHANGE_OBJECT_TO_R12()
	(INTEGNPS:CHANGE_OBJECT_TO_R12)
)

(defun INTEGNPS:CODE_FILENAME_AS_PARAMETER(filename / coded_filename i len ch)
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(setq i 1)
	(setq coded_filename "")
	(setq len (if (/= nil filename) (strlen filename) 0))
	(while (<= i len)
		(setq ch (substr filename i 1))
		(if (= " " ch)
			(setq coded_filename (strcat coded_filename "%20"))
			(setq coded_filename (strcat coded_filename ch))
		)
		(setq i (+ i 1))
	)
	(setvar "cmdecho" old_cmdmode)
	(print coded_filename)
)

(defun INTEGNPS:DXFOUT(filename /)
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(if (/= nil filename)
		(progn
			(setq INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME filename)
			(command "LAYER" "S" "0" "")
			(if 
				(or
					(= (not (findfile filename)) T)
					(or
						(/= (listp vl-file-delete) nil)
						(= (vl-file-delete filename) T)
					)
				)
				
				(progn
					(command "_dxfout" filename 16)
					(setvar "cmdecho" old_cmdmode)
					(print T)
				)
				(progn
					(setvar "cmdecho" old_cmdmode)
					(print nil)
				)
			)
		)
		(progn
			(setvar "cmdecho" old_cmdmode)
			(print nil)
		)
	)
)

(defun INTEGNPS:GET_ACAD_VERSION()
	(print (atof (getvar "acadver")))
)


(defun INTEGNPS:OPENDXF(filename /)
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)

	(if (< (INTEGNPS:GET_ACAD_VERSION) 15)
		(progn
			(command "circle" "0,0" "1");;;force ask for save
			(command "LAYER" "S" "0" "")
			(command "fileopen" "y" filename)
			(command "ZOOM" "E")
			(command "REGEN")
		)
		(progn
			(command "ERASE" "ALL" "")
			(command "PURGE" "A" "*" "N")
			(command "LAYER" "S" "0" "")
			(command "_DXFIN" filename)
			(command "ZOOM" "E")
			(command "REGEN")
		)
	)

	(setvar "cmdecho" old_cmdmode)

	(print)
)

;******************************************************************************************************



;------------------------------------------------------------------------------------------------------
;;private functions or commands
;------------------------------------------------------------------------------------------------------
(defun INTEGNPS:SHELL_DELETE_CNC_START_BLOCKS ()
	(alert (strcat "ɾ " (rtos (INTEGNPS:DELETE_CNC_START_BLOCKS) 2 0) " ־\n" ))
)

(defun C:INTEGNPS_CUT_NEAR(/ blk)
	(if (= nil INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
		(setq blk "START")
		(setq blk INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
	)
	(INTEGNPS:INSERT_BLOCK blk "1" "1" "nea" "\n־׽ʽΪ㣩:")
)
(defun C:INTEGNPS_CUT_END(/ blk)
	(if (= nil INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
		(setq blk "START")
		(setq blk INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
	)
	(INTEGNPS:INSERT_BLOCK blk "1" "1" "end" "\n־׽ʽΪ˵㣩:")
)
(defun C:INTEGNPS_CUT_NEAR_END(/ blk)
	(if (= nil INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
		(setq blk "START")
		(setq blk INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
	)
	(INTEGNPS:INSERT_BLOCK blk "1" "1" "nea+end" "\n־׽ʽΪ+˵㣩:")
)
(defun C:INTEGNPS_CUT_CURRENT(/ blk)
	(if (= nil INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
		(setq blk "START")
		(setq blk INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
	)
	(INTEGNPS:INSERT_BLOCK blk "1" "1" nil "\n־ǰ׽ʽ:")
)

(defun C:INTEGNPS_INNORMAL_CUT_NEAR(/ blk)
	(if (= nil INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
		(setq blk "START")
		(setq blk INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
	)
	(INTEGNPS:INSERT_BLOCK blk "2" "2" "nea" "\n뷴־׽ʽΪ㣩:")
)
(defun C:INTEGNPS_INNORMAL_CUT_END(/ blk)
	(if (= nil INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
		(setq blk "START")
		(setq blk INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
	)
	(INTEGNPS:INSERT_BLOCK blk "2" "2" "end" "\n뷴־׽ʽΪ˵㣩:")
)
(defun C:INTEGNPS_INNORMAL_CUT_NEAR_END(/ blk)
	(if (= nil INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
		(setq blk "START")
		(setq blk INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
	)
	(INTEGNPS:INSERT_BLOCK blk "2" "2" "nea+end" "\n뷴־׽ʽΪ+˵㣩:")
)
(defun C:INTEGNPS_INNORMAL_CUT_CURRENT(/ blk)
	(if (= nil INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
		(setq blk "START")
		(setq blk INTEGNPS_GLOBAL_VAR_CUT_START_FILENAME)
	)
	(INTEGNPS:INSERT_BLOCK blk "2" "2" nil "\n뷴־ǰ׽ʽ:")
)

(defun C:INTEGNPS_DRAW_PLATE()
	(setq fLong (GETREAL "\nĳ:"))
	(if (<= fLong 0)
		(progn
			(alert "ĳȱ㡣")
		)
		(progn
			(setq fWidth (GETREAL "\nĿ:"))
			(if (<= fWidth 0)
				(progn
					(alert "Ŀȱ㡣")
				)
				(INTEGNPS:DRAW_PLATE fLong fWidth)
			)
		)
	)
	(print)
)

(defun C:INTEGNPS_OPEN_NESTING(/)
	(setq tmp_dxfname
		(getfiled
			"ѡͼļ"
			(if (/= nil INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME)
				INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME
				""
			)
			"DXF"
			2
		)
	)
	
	(if (/= nil tmp_dxfname)
		(progn
			(setq INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME tmp_dxfname)
			(INTEGNPS:OPENDXF tmp_dxfname)
			(print tmp_dxfname)
			(print)
		)
		(print)
	)
)

(defun C:INTEGNPS_SAVE_NESTING(/ coded_dxfname tmp_dxfname)
	(setq tmp_dxfname 
		(getfiled
			"뱣ͼļ" 
			(if (/= nil INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME)
				INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME
				""
			)
			"DXF"
			1
		)
	)
	
	(if (/= tmp_dxfname nil)
		(if (/= (INTEGNPS:DXFOUT tmp_dxfname) T)
			(alert "ͼļʧܡ\n\nļǷѾ򿪻ļǷɱǡ\n\nļѾȹرա")
		)
	)
	
	(print)
	
)

(defun C:INTEGNPS_SAVE_AND_PROGRAMMING(/ coded_dxfname tmp_dxfname)
	(setq tmp_dxfname 
		(getfiled
			"뱣ͼļ" 
			(if (/= nil INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME)
				INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME
				""
			)
			"DXF"
			1
		)
	)
	
	(if (/= tmp_dxfname nil)
		(if (= (INTEGNPS:DXFOUT tmp_dxfname) T)
	
			(progn 
				(setq coded_dxfname (INTEGNPS:CODE_FILENAME_AS_PARAMETER tmp_dxfname))

				(if (> (strlen coded_dxfname) 0)
					(startapp INTEGNPS_GLOBAL_VAR_EXE_FILENAME (strcat "/gnp_program " coded_dxfname))
				)
			)
			(alert "ͼļʧܡ\n\nļǷѾ򿪻ļǷɱǡ\n\nļѾȹرա")
		)
	)
	
	(print)
	
)

(defun C:INTEGNPS_SAVE_AND_AUTO_NESTING(/ coded_dxfname tmp_dxfname)
	(setq tmp_dxfname 
		(getfiled
			"뱣ͼļ" 
			(if (/= nil INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME)
				INTEGNPS_GLOBAL_VAR_LAST_DXFOUT_FILENAME
				""
			)
			"DXF"
			1
		)
	)
	
	(if (/= tmp_dxfname nil)
		(if (= (INTEGNPS:DXFOUT tmp_dxfname) T)
	
			(progn 
				(setq coded_dxfname (INTEGNPS:CODE_FILENAME_AS_PARAMETER tmp_dxfname))

				(if (> (strlen coded_dxfname) 0)
					(startapp INTEGNPS_GLOBAL_VAR_EXE_FILENAME (strcat "/gnp_auto_nesting " coded_dxfname))
				)
			)
			(alert "ͼļʧܡ\n\nļǷѾ򿪻ļǷɱǡ\n\nļѾȹرա")
		)
	)
	
	(print)
	
)

(defun C:INTEGNPS_DRAW_PARALLEL()
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(setq old_osnap (getvar "osmode"))
	(command "OSNAP" "NEA")
	(SETQ A (GETPOINT "\nѡ֪߶ϵһ(߶ζ˵):"))
	(SETQ B (OSNAP A "END"))
	(command "OSNAP" "NONE")
	(SETQ B1 (GETPOINT "\nѡƽ߶˵:"))
	(princ B1)
	(command "OSNAP" "NONE")
	(command "COPY" A "" B B1)
	(setvar "osmode" old_osnap)
	(setvar "cmdecho" old_cmdmode)
	(print)
)

(defun C:INTEGNPS_DRAW_VERTICAL_LINE()
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(setq old_osnap (getvar "osmode"))
	(SETQ P1 (GETPOINT "\nѡ֪:"))
	(command "OSNAP" "NEA")
	(SETQ A1 (GETPOINT "\nѡ֪:"))
	(command "OSNAP" "NONE")
	(command "LINE" P1 "PERP" A1 "")
	(setvar "osmode" old_osnap)
	(setvar "cmdecho" old_cmdmode)
	(print)
)

(defun C:INTEGNPS_DRAW_ANGLE_LINE()
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(setq old_osnap (getvar "osmode"))
	(command "OSNAP" "NEA")
	(SETQ A (GETPOINT "\nѡ֪:"))
	(COMMAND "SETVAR" "OSMODE" "513")
	(SETQ B (GETPOINT "\nѡ֪ϵĻ:"))
	(SETQ G (GETANGLE "\nǶ(ʱΪֵ):"))
	(SETQ D  (GETREAL "\n뽻ߵĳ:"))
	(SETQ AG (ANGLE B A))
	(SETQ AG (+ AG G))
	(SETQ C (POLAR B AG D))
	(command "OSNAP" "NONE")
	(command "LINE" B C "")
	(setvar "osmode" old_osnap)
	(setvar "cmdecho" old_cmdmode)
	(print)
)

(defun C:INTEGNPS_DRAW_POINT_TAN_TO_ARC()
	(setq old_cmdmode (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(setq old_osnap (getvar "osmode"))
	(SETQ A (GETPOINT "\nѡߵ:"))
	(command "OSNAP" "NEA")
	(SETQ B (GETPOINT "\nѡԲ(Բ)ϵһ:"))
	(command "OSNAP" "NONE")
	(command "LINE" A "QUICK,TAN" B "")
	(setvar "osmode" old_osnap)
	(setvar "cmdecho" old_cmdmode)
	(print)
)

(defun INTEGNPS:INTEGNPS_EXPLODE_TEXT(exptxt_vlx_filename /)
	(if (< (INTEGNPS:GET_ACAD_VERSION) 15)
		(progn
			(alert "ùҪ AutoCAD 2000 ϰ汾")
			(print nil)
		)
		(progn
			(load exptxt_vlx_filename)
			(print T)
		)
	)
)
;------------------------------------------------------------------------------------------------------


;;;the last line is return value
(print)
